// FractalGUIDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FractalGUI.h"
#include "FractalGUIDlg.h"
#include "fractalg.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
CString	m_filename;
int backupy;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFractalGUIDlg dialog

CFractalGUIDlg::CFractalGUIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFractalGUIDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFractalGUIDlg)
	m_amplitude = 0.0f;
	m_frequency = 0.0f;
	m_yp = 0.0f;
	m_xp = 0.0f;
	m_passes = 0;
	drawnewfractal=0;
	m_offset = 0.0f;
	m_mfractal = FALSE;
	m_h = 0.0f;
	m_XSIZE = 0;
	m_YSIZE = 0;
	m_freqchange = 0.0f;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFractalGUIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFractalGUIDlg)
	DDX_Text(pDX, IDC_EDIT2, m_amplitude);
	DDX_Text(pDX, IDC_EDIT3, m_frequency);
	DDX_Text(pDX, IDC_EDIT6, m_yp);
	DDX_Text(pDX, IDC_EDIT4, m_xp);
	DDX_Text(pDX, IDC_EDIT1, m_passes);
	DDX_Text(pDX, IDC_EDIT7, m_offset);
	DDX_Check(pDX, IDC_CHECK1, m_mfractal);
	DDX_Text(pDX, IDC_EDIT5, m_h);
	DDX_Text(pDX, IDC_EDIT10, m_XSIZE);
	DDV_MinMaxInt(pDX, m_XSIZE, 0, 2147483647);
	DDX_Text(pDX, IDC_EDIT8, m_YSIZE);
	DDX_Text(pDX, IDC_EDIT9, m_freqchange);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFractalGUIDlg, CDialog)
	//{{AFX_MSG_MAP(CFractalGUIDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFractalGUIDlg message handlers

BOOL CFractalGUIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CWnd* pwnd=GetDlgItem(IDC_EDIT7);
	pwnd->EnableWindow(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFractalGUIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFractalGUIDlg::OnPaint() 
{
	
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);
    	COLORREF test;
		if(drawnewfractal==1)
		{
	    int every2=0;		
		for(int y=0;y<m_YSIZE;y++)
		for(int i=0;i<m_XSIZE;i++)
		{
		test=RGB(heightmap[y][i]*10,heightmap[y][i]*10,heightmap[y][i]*10);
		dc.SetPixel(i+150,y+50,test);
		}
		}
	
	}
}
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFractalGUIDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFractalGUIDlg::OnOK() 
{

	UpdateData(TRUE);
	if(drawnewfractal==1)
	{
	for(int i=0;i<backupy;i++)
	{
	delete []heightmap[i];
	}
	delete []heightmap;
	heightmap=0;
	}
	else
	{
	backupy=m_YSIZE;
	}
 	heightmap = new float*[ m_YSIZE ];

	// now for each x we want a [ y ] array

	for( int i = 0; i < m_YSIZE; i++ )
	{
		heightmap[ i ] = new float[ m_XSIZE ];
		
	}
	float temp=0;
	for(int y=0;y<m_YSIZE;y++)
	{
	for(int x=0;x<m_XSIZE;x++)
	{
	if(m_mfractal==false)
	{
	temp=FBM(x+m_xp,y+m_yp,m_passes,m_amplitude,m_frequency,m_h,m_freqchange);
	}
	else
	{
	temp=MultiFractal(x+m_xp,y+m_yp,m_passes,m_amplitude,m_frequency,m_h,m_offset,m_freqchange);
	}
	heightmap[y][x]=temp;
	}
	}
	drawnewfractal=1;
	InvalidateRect(NULL,TRUE);
	// TODO: Add extra validation here
	
}

void CFractalGUIDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
CFileDialog dialog(FALSE,"raw",NULL,OFN_OVERWRITEPROMPT,NULL,NULL);	
int test=dialog.DoModal();
if(test==IDOK)
{
m_filename=dialog.GetFileName();
dumplist(m_XSIZE,m_YSIZE,m_filename);
m_filename="";
}
}

void CFractalGUIDlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	bool static i=true;
	if(i==true)
	{
	CWnd* pwnd=GetDlgItem(IDC_EDIT7);
	pwnd->EnableWindow(TRUE);
	i=false;
	}
	else
	{
	CWnd* pwnd=GetDlgItem(IDC_EDIT7);
	pwnd->EnableWindow(FALSE);
	i=true;
	}

}


void CFractalGUIDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(drawnewfractal==1)
	{
	for(int i=0;i<m_YSIZE;i++)
	{
	delete []heightmap[i];
	}
	delete []heightmap;
	heightmap=0;
	}
	CDialog::OnCancel();
}

void CFractalGUIDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
		if(point.x>150&&point.y>50&&drawnewfractal==1&&point.x<150+m_XSIZE&&point.y<50+m_XSIZE&&nFlags==MK_LBUTTON)
	{
		heightmap[point.y-50][point.x-150]+=5;
		heightmap[point.y-50][point.x-150+1]+=5;
		heightmap[point.y-50+1][point.x-150]+=5;
		heightmap[point.y-50][point.x-150-1]+=5;
		heightmap[point.y-50-1][point.x-150]+=5;
		//
	
	}
	if(point.x>150&&point.y>50&&drawnewfractal==1&&point.x<150+m_XSIZE&&point.y<50+m_XSIZE&&nFlags==MK_RBUTTON)
	{
		heightmap[point.y-50][point.x-150]-=5;
		heightmap[point.y-50][point.x-150+1]-=5;
		heightmap[point.y-50+1][point.x-150]-=5;
		heightmap[point.y-50][point.x-150-1]-=5;
		heightmap[point.y-50-1][point.x-150]-=5;
		
	}


	InvalidateRect(NULL,FALSE);
	CDialog::OnMouseMove(nFlags, point);
}
